﻿using System;
using System.Collections.ObjectModel;
using System.Xml.Linq;
using System.Net;
using System.IO;
using System.IO.IsolatedStorage;
using System.Xml.Serialization;
using System.Xml;
using System.Linq;

namespace Tehnikum
{
    public class PeaVaateMudel
    {
        private ObservableCollection<Uudis> _uudised = new ObservableCollection<Uudis>();
        public ObservableCollection<Uudis> Uudised 
        {
            get { return _uudised; }
        }
        
        public bool KasAndmedOnLaetud = false;
        /// <summary>
        /// Siin kirjeldame, kust ja kuidas andmed
        /// saadakse
        /// </summary>
        public void LaeAndmed()
        {
            //Uudis uusUudis = new Uudis();
            //uusUudis.Pealkiri = "Uudis 1";
            //uusUudis.Kirjeldus = "Uudis 1 kirjeldus";
            //this._uudised.Add(uusUudis);
            //this._uudised.Add(new Uudis(){Pealkiri="Uudis 2", Kirjeldus="Uus uudis 2 tekst"});
            //this._uudised.Add(new Uudis() { Pealkiri = "Uudis 3", Kirjeldus = "Uus uudis 3 tekst" });
            //this._uudised.Add(new Uudis() { Pealkiri = "Uudis 4", Kirjeldus = "Uus uudis 4 tekst" });
            using (IsolatedStorageFile minuStorage =
                IsolatedStorageFile.GetUserStoreForApplication())
            {
                if(minuStorage.FileExists("Uudised.xml"))
                {
                    XmlSerializer serialiseerija =
                        new XmlSerializer(typeof(ObservableCollection<Uudis>));
                    using (IsolatedStorageFileStream voog =
                        minuStorage.OpenFile("Uudised.xml", FileMode.Open))
                    {
                        ObservableCollection<Uudis> vanadUudised =
                            (ObservableCollection<Uudis>)serialiseerija.Deserialize(voog);
                        foreach (var x in vanadUudised)
                        {
                            this._uudised.Add(x);
                        }
                        
                    }
                }
            }
            
            
            WebClient veebiKlient = new WebClient();
            veebiKlient.DownloadStringCompleted += 
                new DownloadStringCompletedEventHandler(veebiKlient_DownloadStringCompleted);
            veebiKlient.DownloadStringAsync(
                new Uri("http://www.vpg.edu.ee/tekst.php"));
            
            KasAndmedOnLaetud = true;
        }

        public void SalvestaAndmed()
        {
            XmlWriterSettings xmlSeaded = new XmlWriterSettings();
            xmlSeaded.Indent = true;
            using (IsolatedStorageFile minuStorage =
                IsolatedStorageFile.GetUserStoreForApplication())
            {
                using(IsolatedStorageFileStream voog = 
                    minuStorage.OpenFile("Uudised.xml",FileMode.Create))
                {
                    XmlSerializer serialiseerija =
                        new XmlSerializer(typeof(ObservableCollection<Uudis>));
                    using (XmlWriter kirjutaja =
                        XmlWriter.Create(voog, xmlSeaded))
                    {
                        serialiseerija.Serialize(kirjutaja, this.Uudised);
                    }
                }
            }
        }

        public void veebiKlient_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            if (e.Error == null && e.Result != "")
            {
                XDocument minuRSS = XDocument.Parse(e.Result);
                var itemid = minuRSS.Descendants("item").Take(10);
                this._uudised.Clear();
                foreach (var x in itemid)
                {
                    Uudis uusUudis = new Uudis();
                    uusUudis.Pealkiri = HttpUtility.HtmlDecode(x.Element("title").Value);
                    string tmpKirjeldus = x.Element("description").Value;
                    
                    System.Text.RegularExpressions.Regex regulaar =
                        new System.Text.RegularExpressions.Regex("<[^>]*>");
                    tmpKirjeldus = regulaar.Replace(tmpKirjeldus, "");
                    tmpKirjeldus = HttpUtility.HtmlDecode(tmpKirjeldus);
                    uusUudis.Kirjeldus = tmpKirjeldus;
                    this._uudised.Add(uusUudis);
                }
                SalvestaAndmed();
            }
        }
        
    }
}
